<? if ( !defined("_INCLUDED_GLOBAL") ) exit;		// [Security]Allow_url_fopen = On ?>
<?


###############################################################################
# Global Variables
###############################################################################


	// user - 사이트정보 (도메인별 설정)
		#$G_SYS[ADMIN_EMAIL] = "postmaster@도메인";
		$G_SYS[ADMIN_EMAIL_NAME] = "관리자";
		#$G_SYS[SITE_NAME] = "웹메일";		// ex) 패스코리아넷 웹메일
		#$G_SYS[SITE_OWNER] = "패스코리아넷";		// ex) 패스코리아넷
		#$G_SYS[SITE_TITLE] = "Nmail Linux/Unix 2.0 for PHP - http://passkorea.net";


	// user - 서버설정
		#$G_SYS[MBR_ID_DENY] = array('root', 'admin', 'superadmin', 'demo', 'mail', 'nmail', 'webmail', 'master', 'webmaster', 'postmaster', 'abuse', 'service', 'help');		// 회원가입시 제한할 ID 목록.(무제한 버젼에서만 디폴트로 필요할 듯.)
		$G_SYS[SMTP_ADDR] = "127.0.0.1";		// smtp server address.  default: 127.0.0.1
		$G_SYS[SMTP_PORT] = 25;		// smtp server port.  default: 25
		#$UPLOAD_MAX_SIZE = 10485760;	// 업로드 제한용량.  ex) 1024 * 1024 * 1 = 1MB(1048576)
		#$G_SYS[UPLOAD_MAIL_MAX_SIZE] = 10485760;	// 메일 첨부파일 제한용량.  기본 - 10MB(10485760)
		#$G_SYS[VIRUS_SCAN] = false;		// 바이러스 메일 검사여부.(옵션팩이 설치되어 있어야 함.)
		$G_SYS['WEBEDITOR'] = 'TINYMCE';		// TINYMCE - TinyMCE, OPEN - openWYSIWYG


	// 스팸 필터 / 스팸 편지함을 생략하는 기능.  (기본 false)
		// 생략할 경우 스팸 필터가 동작되지 않고, 스팸편지함이 사용자에게 보여지지 않음.
		$G_SYS['SPAM_CHECK_SKIP'] = false;

		
	// 스킨 설정
		$NSKIN['ver'] = '2.0';		// 스킨 버젼.

	
	// 웹메일 설정
		$G_SYS['DRAFT_SAVE_AUTO_TIME'] = 120;		// 편지쓰기시 '임시보관함에 자동 저장하기'간격.(기본 120초, 2분)


	// 웹하드 설정
		$G_SYS['WEBHARD_NAME'] = '웹하드';		// 웹하드 명칭(웹디스크, 파일박스 ...)


	// system - DB
		include_once("include/global_db.php");


	// system - Session
		$G_SYS[SESSION_LIFETIME] = 0;		// 세션 유효시간.  초단위.
		$G_SYS[SESSION_PATH] = "/";		// 세션 유효경로.
		$G_SYS[SESSION_DOMAIN] = "";		// 세션을 공유할 경우에만 도메인명 입력.  ex) .domain.com => www.domain.com, club.domain.com
		$G_SYS[SESSION_GC_MAXLIFETIME] = 7200;		// 세션 찌꺼기 제거시간.		ex) 1시간 => 3600, 2시간 => 7200


	// system - 개발자용
		$G_SYS[PAGE_ROOT] = dirname(dirname(__FILE__));
		// [2005-08-04] 루트, 서브 디렉토리에서 URL로 바로 접근하는 소스의 경로차이 보정.
		if ($G_SYS[PAGE_ROOT] == dirname(realpath($_SERVER['SCRIPT_FILENAME'])))
		{
			$G_SYS[URL_ROOT] = dirname($_SERVER["PHP_SELF"]);
		} else
		{
			$G_SYS[URL_ROOT] = dirname(dirname($_SERVER["PHP_SELF"]));
		}	// if()
		if ( ($G_SYS[URL_ROOT] == "/") || ($G_SYS[URL_ROOT] == "\\") ) $G_SYS[URL_ROOT] = "";
		$G_SYS[HTTP_URL_ROOT] = "http://" . $_SERVER["HTTP_HOST"] . $G_SYS[URL_ROOT];

		$G_SYS[MAIL_DOMAIN_DEFAULT_SIZE] = 10485760;		// 메일용량 할당량.  kbyte단위.  ex) 10485760 => 10G
		$G_SYS[MAIL_DEFAULT_SIZE] = 102400;		// 기본 메일용량.  kbyte단위.  ex) 102400 => 100MB
		$G_SYS[MBR_DEFAULT_COUNT] = 100;		// 메일유저 할당수.  명단위.

		// [2006-09-05] Windows
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		{
			$G_SYS[MAIL_ROOT] = "C:\NmailPHP\MailRoot\domains";
			$G_SYS[PAGE_ROOT] = str_replace('\\', '/', $G_SYS[PAGE_ROOT]);
			$G_SYS[MAIL_ROOT] = str_replace('\\', '/', $G_SYS[MAIL_ROOT]);
		} else 
		{
			$G_SYS[MAIL_ROOT] = "/var/MailRoot/domains";			
		}	// if()

		$G_SYS[WEBLOGS_DIR] = dirname($G_SYS[PAGE_ROOT])."/weblogs";
		$G_SYS[FILTERTEMP_DIR] = dirname($G_SYS[PAGE_ROOT])."/filtertemp";
		$G_SYS[MAILTO] = "mail_write.php?mf_to=";
		// 회원 비밀번호 암호화 방식 지정.  회원이 가입된 이후에는 절대 변경하면 안됩니다.
		$G_SYS[PWD_ENC] = "MD5";		// MD5, MYSQL (기본값은 MD5)
		$G_SYS[CHARSET] = "euc-kr";
		$G_SYS[LC_CTYPE] = "ko_KR.eucKR";
		$G_SYS['MBR_GROUP_MAX'] = 20;		// 하나의 디렉토리/디비테이블에 들어갈 회원수.   (기본 20명, 사용안함일땐 999999 입력)
		$G_SYS['BOARD_QUOTA_DEFAULT'] = 2097152;		// 도메인별 기본 게시판 첨부 할당량.  기본 - 2GB(2097152)
		$G_SYS['CHARSETS_ISUSE'] = false;		// 편지쓰기시 인코딩 선택여부 (유니코드 버젼에만 적용)

		// [2007-01-17]메일읽기시 삭제하는 태그를 변경할 수 있습니다.
		// '태그|태그'형식이어야 하며 중간에 잘못된 문자가 들어갈 경우 에러가 발생합니다.
		$G_SYS['MAIL_READ_DEL_TAGS'] = 'html|body|iframe|link|meta|object|embed|form|base';

		$G_SYS[PRE_FIX] = "nmail_";

		$UPLOAD_ROOT = $G_SYS[PAGE_ROOT] . "/data";
		$UPLOAD_DIR[CONFIG] = "config";
		$UPLOAD_DIR[MEMBER] = "member";
		$UPLOAD_DIR[BOARD] = "board";
		$UPLOAD_ISHIDDEN = true;		// upload 된 파일들의 url을 숨길지 여부.(숨길 경우 이미지파일이 캐쉬에 저장되지 않아 불편한점이 있을 수 있음.)
		$CHMOD_CHANGE = 0707;		// upload 내의 퍼미션.  ex) -rwx---rwx
		$CHMOD_CHANGE_STR = "707";		// upload 내의 퍼미션.  ex) -rwx---rwx
		$UPLOAD[FILTER_EXT][IMG] = array("jpg", "jpeg", "gif", "png", "pcx", "bmp", "tif", "tiff");
		$UPLOAD[FILTER_EXT][FLASH] = array("swf");

		/*
			debug info

			VIEW : 화면 하단에 바로 출력함.
			HIDDEN : html 소스 하단에 주석형태로 출력함.

		*/
		#$G_SYS['DEBUG_TYPE'] = 'VIEW';
		$G_SYS['DEBUG_TYPE'] = 'HIDDEN';

		// [2005-09-07]
		#$G_SYS['DEBUG_QUERY'] = 'VIEW';
		$G_SYS['DEBUG_QUERY'] = 'HIDDEN';

		// [2005-12-11]
		$G_SYS['DEBUG_QUERY_OVER_TIME'] = 2;		// 지정된 시간(sec)보다 응답이 느린 쿼리는 기록을 남기도록 함.  기본 : 2sec.


###############################################################################


	// Level
		/* Level ex
			level : 0
			level_name : 손님
			level_key : guest
		*/
		$G['LEVEL'] = array(
								"guest" => 0,
								"out" => 1,
								"wait" => 2,
								"user" => 3,
								"admin" => 7,
								"serveradmin" => 9
								);							

		$G['LEVEL_NAME'] = array(
								0 => "손님",
								1 => "탈퇴회원",
								2 => "가입대기",
								3 => "회원",
								7 => "관리자",
								9 => "서버관리자"
								);


###############################################################################


	// Member
		$G_MB[DEFAULT_JOIN_LEVEL] = $G[LEVEL][wait];		// 가입시 부여될 레벨.  ex) user -> 3 -> 일반개인회원
		$G_MB[DEFAULT_JOIN_LEVEL_BYADMIN] = $G[LEVEL][user];		// 관리자가 회원추가시 부여될 레벨.  ex) user -> 3 -> 일반개인회원
		#$G_MB[ISCHECK_JUMIN_DUPLICATE] = true;		// 회원가입시 주민등록번호 중복체크를 사용할지 여부.  ex) true -> 중복체크함, false -> 중복체크안함.
		$G_MB[ISCHECK_JUMIN_DUPLICATE] = false;		// 회원가입시 주민등록번호 중복체크를 사용할지 여부.  ex) true -> 중복체크함, false -> 중복체크안함.
		#$G_MB[ID_MIN_LENGTH] = 2;		// 아이디 최소길이 제한.  기본 2자이상.

		// 외부회원모듈 연동 사용여부. (Y, N)
		$G_SYS['SSO_ISUSE'] = 'N';

		// 외부회원모듈과의 연동처리시 보안을 위한 보안키입니다.(엔메일과 외부회원모듈에서 값이 동일해야 함.)
		// 외부에 유출되지 않도록 유의하시고 설치후 반드시 아래 값을 임의의 문자열(32자내외)로 바꾸시기 바랍니다.
		$G_SYS['SSO_KEY'] = '';

		// 외부회원모듈 가입/수정/탈퇴 링크.(외부회원모듈의 해당 링크를 따로 지정할 수 있습니다.)
		$G_SYS['SSO_JOIN_URL'] = '';		// 기존 사이트의 회원가입 주소
		$G_SYS['SSO_JOIN_URL_TARGET'] = '';		// 프레임으로 구성된 경우 타겟 지정
		$G_SYS['SSO_MODIFY_URL'] = '';		// 기존 사이트의 회원정보수정 주소
		$G_SYS['SSO_MODIFY_URL_TARGET'] = '';		// 프레임으로 구성된 경우 타겟 지정
		$G_SYS['SSO_OUT_URL'] = '';		// 기존 사이트의 회원탈퇴 주소
		$G_SYS['SSO_OUT_URL_TARGET'] = '';		// 프레임으로 구성된 경우 타겟 지정
		$G_SYS['SSO_PASSWDFIND_URL'] = '';		// 기존 사이트의 비밀번호찾기 주소
		$G_SYS['SSO_PASSWDFIND_URL_TARGET'] = '';		// 프레임으로 구성된 경우 타겟 지정
		$G_SYS['SSO_NOT_URL_MSG'] = "외부회원모듈을 사용하도록 설정되었습니다.\\n\\n웹메일의 회원관리 기능을 사용하실 수 없습니다.";
		$G_SYS['SSO_JOIN_LEVEL'] = $G[LEVEL][wait];		// 외부회원모듈에서 가입시 부여될 레벨.   '일반회원'은 'wait'대신 'user'로 변경.

		// 다른 사이트의 frame내에 웹메일을 넣을때 로고등이 중복되는 것을 방지하기 위함.
		$G_SYS['SSO_SKIN_TOP_LOGO_HIDDEN'] = false;		// ex) true -> 로고 숨김, false -> 로고 보여줌.
		$G_SYS['SSO_SKIN_TOP_MENU_HIDDEN'] = false;		// ex) true -> 상단메뉴 숨김, false -> 상단메뉴 보여줌.


	// 일정관리
		// 일정분류(최대 255개) - 배열 앞부분의 숫자는 중간에 누락되면 안되며, 디비에 저장되므로 변경하면 안됩니다.
			$G_SYS['DI_KIND'] = array(
				1=>'약속', 
				2=>'행사', 
				3=>'기념', 
				4=>'출장', 
				5=>'휴가', 
				6=>'기타'
				);
			$G_SYS['DI_KIND_KEY'] = array_keys($G_SYS['DI_KIND']);
			$G_SYS['DI_KIND_VAL'] = array_values($G_SYS['DI_KIND']);
		// 되풀이
			$G_SYS['DI_REPEAT'] = array(
				'N'=>'없음', 
				'Y'=>'매년(양력)', 
				'L'=>'매년(음력) '
				);
		// 요일
			$G_SYS['DAYOFWEEK'] = array("일", "월", "화", "수", "목", "금", "토");


	// 메일 자동 분류
		// [2011-03-29] 계속이동 버튼 추가
		//$G_SYS['AUTO_FILTER_MAX'] = 20;		// 개인당 최대 20개까지 등록 가능.
		$G_SYS['AUTO_FILTER_MAX'] = 50;		// 개인당 최대 50개까지 등록 가능.


	// 편지함 보관기간
		$G_SYS['MB_SAVEDAY'] = array(
			0=>'제한없음',
			5=>'5일',
			10=>'10일',
			15=>'15일',
			20=>'20일',
			25=>'25일',
			30=>'30일',
			40=>'40일',
			50=>'50일',
			60=>'60일'
			);
		$G_SYS['MB_SAVEDAY_ID'] = array('trash', 'spam');

	// [2006-07-25] 기본 설정 - 편지함마다 보여줄 편지수, 이번주 일정 표시수
		$G_SYS['M_CFG_NEW_CNT'] = array(
			3=>'3개',
			5=>'5개',
			7=>'7개',
			10=>'10개',
			15=>'15개'
			);		

	// [2006-07-25] 기본 설정 - 편지읽기 목록
		$G_SYS['M_CFG_MAIL_LIST_CNT'] = array(
			10=>'10개',
			15=>'15개',
			20=>'20개',
			30=>'30개',
			50=>'50개',
			75=>'75개',
			100=>'100개'
			);		

	// [2006-11-01] 부재중 자동응답 - 자동응답시 제목앞에 강제로 붙을 문구.
	$G_SYS['AUTOREPLY_SUBJECT_PREFIX'] = "[부재중 자동응답] ";


###############################################################################


	// Board
		$G_BOARD[S_KIND] = array(
										"b_subject"=>"제목",
										"b_memo"=>"내용",
										"b_name"=>"작성자",
										"ALL"=>"전체"
										);

		$G_BOARD[S_KIND_ADMIN] = array(
										"mu.mu_name"=>"이름",
										"ba.ba_isuse_link"=>"링크",
										"ba.ba_isuse_file"=>"파일",
										"ba.ba_isuse_comment"=>"덧말",
										"ba.ba_isuse_reply"=>"답변",
										"ba.ba_regdate"=>"생성일자",
										"ba.ba_last_modifydate"=>"수정일자"
										);

		// 새로운게시물 기준시간(초단위)
		$G_BOARD[NEW_TIME] = 259200;		// 60*60*24*3 = 259200 (3일이내)

		// 공지사항 지정시 내용길이 자르기(등록폼에서 보여질때만 사용되며, 실제 등록시엔 이 값과 무관함)
		$G_BOARD[NOTICE_LENGTH] = 500;		// 500 byte


###############################################################################


	// General

		$G[ISSIGN] = array(
								"Y" => "승인",
								"N" => "비승인"
								);

		$G[ISUSE] = array(
								"Y" => "사용함",
								"N" => "사용안함"
								);

		$G[ISNOTNULL] = array(
								"Y" => "필수입력",
								"N" => "일반입력"
								);

		$G[ISLIST] = array(
								"Y" => "목록표시",
								"N" => "목록표시안함"
								);

		$G[ISSYSTEM] = array(
								"Y" => "시스템항목",
								"N" => "일반항목"
								);

		$G[ISVOTE] = array(
								"Y" => "추천함",
								"N" => "추천하지않음"
								);

		$G[ISPOSSIBLE] = array(
								"Y" => "가능",
								"N" => "불가"
								);

		$G[BIRTHDAY_EAST] = array(
								"S" => "양력",
								"L" => "음력"
								);

		$G[ISREMAIL] = array(
								"Y" => "수신함",
								"N" => "수신하지않음"
								);


		$G[ISUSE_REPLY_MAIL] = array(
								"Y" => "답변메일 받음",
								"N" => "답변메일 받지않음"
								);

		$G[ISSEND] = array(
								"N" => "발송대기",
								"Y" => "발송완료"
								);

		$G[SEX] = array(
								"M" => "남자",
								"F" => "여자"
								);

		$G[ISMARRY] = array(
								"Y" => "기혼",
								"N" => "미혼"
								);

		$G[JOB] = array(
								"중학교 이하",
								"고등학생",
								"대학(원)생",
								"사무직",
								"기술직",
								"서비스/판매직",
								"생산직",
								"정보통신 관련직",
								"의료인",
								"방송/언론인",
								"법조인",
								"종교인",
								"예능/예술인",
								"전문직",
								"주부",
								"자영업",
								"농/축/수산",
								"공무원",
								"교사/교수",
								"비영리단체",
								"무직",
								"군인",
								"기타"
								);

		$G[HTML] = array(
										"N"=>"TEXT",
										"Y"=>"HTML",
										"M"=>"HTML + <BR>"
										);

		$G[AND_OR] = array(
								"AND",
								"OR"
								);


###############################################################################


?>